// Gerard Paresys
// 12 9 2012
//
// TDM23a + layers
//
// Un dossier (pas necessairement le dossier data) doit comporter 4 fichiers nommés:
//   XXX.xml  (format Praat TextGrid)
//   XXX.mp3
//   XXX_Pitch.txt
//   XXX_Intensity.txt
// et
//   Helvetica-50.vlw
//
// Touche S Sauve l'ecran (format png)
// Touche Espace    Pause 
// Touche Fleche <- Zoom Out 
// Touche Fleche -> Zoom In 
// Touche P Phonème 
// Touche Y Syllabe 
// Touche M Mot 
// Clic souris dans la fenêtre d'abord  
// Ouvre         le fichier       XXX.xml
// Ouvre et joue le fichier Audio XXX.mp3 
// Ouvre         le fichier texte XXX_Pitch.txtt    généré par Praat
// Ouvre         le fichier texte XXX_Intensity.txt généré par Praat
// Dessine les courbes Pitch et Intensity synchronisées avec l'Audio 
// La courbe Pitch n'est pas dessinée quand pitch est "undefined" 
// Chronomètre... 

import ddf.minim.*;  // pour AudioPlayer
import ddf.minim.analysis.*;  // Pour FFT
import com.nootropic.processing.layers.*;  // Pour layers

import fullscreen.*; 
FullScreen fs;

PFont  maFonte;
PImage BackGroundImage;

float   FacteurX               = 16;    // Vitessse courbes Pitch et Intensity
int     CoucheSpectre          = 2;     //0 Phonème, 1 Syllabe, 2 Mot, 3 Phonétique, 4 Orthographique
int     CoucheHaut             = 1;     //0 Phonème, 1 Syllabe, 2 Mot, 3 Phonétique, 4 Orthographique
int     CoucheBas              = 0;     //0 Phonème, 1 Syllabe, 2 Mot, 3 Phonétique, 4 Orthographique
boolean FlagLigneHaut          = false;  // true ou false
boolean FlagTexteHaut          = false;  // true ou false
boolean FlagLigneBas           = true;   // true ou false
boolean FlagTexteBas           = true;   // true ou false
int     PitchMini              = 75 ;  // 75 Hz
int     PitchMaxi              = 500;  // 500 Hz
int     EpaisseurCourbe        = 3;    // Courbes Pitch & Intensity
int     AdjustBlurSpectrum     = 5;    //+ AdjustBlur est grand, - il y a de blur
int     AdjustBlurTextSpectrum = 4;    //+ AdjustBlur est grand, - il y a de blur
String  NomFichierBackGround   = "trousdememoire.jpg";

String NomFichierAudio;
String NomFichierPitch;
String NomFichierIntensity;
String NomFichierXML;
float PitchActuel = PitchMini;    
String[] LignesPitch;
String[] LignesIntensity;
int IndexPitch = 0;
int IndexIntensity = 0;
float xAvantPitch, xApresPitch, yAvantPitch, yApresPitch;
float xAvantIntensity, xApresIntensity, yAvantIntensity, yApresIntensity;
int LigneText, x;
AudioPlayer MonPlayer;
Minim minim;
float temps, DureeFichier;
boolean Probleme = false, Fin = false;
boolean ToucheEspace = false, Pause = false, Trace = false;
float[] LignePitch, LigneIntensity;
float TempsPause, TempsDebutPause = 0;
XMLElement xml1, kid1, kid2;
XMLElement[] kid1Data, kidkid1Data;
int NombreDeChild1, NombreDeChild2;
int IndexXMLSpectre = 0, IndexXMLCouche4 = 0, IndexXMLHaut = 0, IndexXMLBas = 0;
float xmin, xmax;
String s1, s2, Content1, Content2;
int colmax, colFixe ; // Spectrogram size (pixels)
int rowmax ;          // Spectrogram size (pixels)
FFT Mafft;
int col = 0;
int Gris;


AppletLayers layers;


void setup() {
  size(800, 600);  // "The size() function must be the first line in setup()"
  // size(800, 600, OPENGL);  // "The size() function must be the first line in setup()"
  // size(800, 600, P3D);  // "The size() function must be the first line in setup()"
  //  size(400, 300);  // "The size() function must be the first line in setup()"
  maFonte = loadFont("Helvetica-50.vlw");
  smooth();
  stroke(160);
  textAlign(LEFT, TOP);
  textFont(maFonte, 16);
  fill(0, 0, 0); // Texte noir
  colmax = width;
  rowmax = height;

  // NomFichierXML = selectInput("select the XML File (format Praat textGrid)");
  NomFichierXML = "13missmilsaveur_Y/13missmilsaveur_Y.xml";
  if (loadStrings(NomFichierXML) == null) { 
    println("Le fichier " + NomFichierXML + " n'existe pas");
    Probleme = true;
  } 
  else {
    String[] list = split(NomFichierXML, '.');
    NomFichierXML = list[0] + ".xml";

    xml1 = new XMLElement(this, NomFichierXML);
    NombreDeChild1 = xml1.getChildCount();
    kid1Data = xml1.getChildren();
    s1 = kid1Data[0].getName();
    // println(s1 + " : " + NombreDeChild1 + " child(s)");
    kidkid1Data = kid1Data[0].getChildren();
    s2 = kidkid1Data[1].getName();
    println("Ouverture de: " + NomFichierXML);

    NomFichierPitch = list[0] + "_Pitch.txt";
    if (loadStrings(NomFichierPitch) == null) { 
      println("Le fichier " + NomFichierPitch + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesPitch = loadStrings(NomFichierPitch);
      println("Ouverture de: " + NomFichierPitch +"  " + LignesPitch.length + " lignes" );
    } 

    NomFichierIntensity = list[0] + "_Intensity.txt";
    if (loadStrings(NomFichierIntensity) == null) { 
      println("Le fichier " + NomFichierIntensity + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesIntensity = loadStrings(NomFichierIntensity);
      println("Ouverture de: " + NomFichierIntensity +"  " + LignesIntensity.length + " lignes" );
    } 

    NomFichierAudio = list[0] + ".mp3";
    if (loadStrings(NomFichierAudio) == null) { 
      println("Le fichier " + NomFichierAudio + " n'existe pas");
      Probleme = true;
    } 
    else {
      println("Ouverture de: " + NomFichierAudio);
      minim = new Minim(this);
      MonPlayer = minim.loadFile(NomFichierAudio, 1024);
    }
  }


  if (! Probleme) { 
    MonPlayer.play();

    LignePitch = float(split(LignesPitch[LignesPitch.length - 1 ], "   "));
    DureeFichier = LignePitch[0];
    println("Duree " + NomFichierPitch + " = " + DureeFichier + " sec");

    LigneIntensity = float(split(LignesIntensity[LignesIntensity.length - 1 ], "   "));
    DureeFichier = LigneIntensity[0];
    println("Duree " + NomFichierIntensity + " = " + DureeFichier + " sec");

    Mafft = new FFT(MonPlayer.bufferSize(), MonPlayer.sampleRate());
    Mafft.window(FFT.HAMMING);
    background(0);  // Fond noir
    // The background image must be the same size as the parameters
    // into the size() method.
    //  BackGroundImage = loadImage("trousdememoire.jpg");
    BackGroundImage = loadImage(NomFichierBackGround);
    background(BackGroundImage);

    // frameRate(30);

    EffaceEcran();
    fs = new FullScreen(this); 
    fs.enter(); // enter fullscreen mode
    TempsPause = millis();
    layers = new AppletLayers(this);
    layers.addLayer(new TextLayer(this));
    layers.addLayer(new PitchLayer(this));
    layers.addLayer(new IntensityLayer(this));
  }
  else exit();
}

void paint(java.awt.Graphics g) {
  if (layers != null) layers.paint(this);
  else super.paint(g);
}

void draw() {
  temps = millis() - TempsPause;

  // Spectre
  Mafft.forward(MonPlayer.mix);
  // fill in the new column of spectral values  
  // println("rowmax = " + rowmax + "  Mafft.specSize() = " + Mafft.specSize());
  for (int i = 0; i < rowmax; i++) {
    Gris = (int)Math.round(Math.max(0, 120*Math.log10(100*Mafft.getBand(i))));
    if (Gris > 255) Gris = 255;
    // stroke(255-Gris); // Inversion Noir <-> Blanc
    stroke(Gris);
    point(col, height - (2 * i) - 1);
    point(col, height - (2 * i) - 2);
  }
  col = col + 1;   // next time will be the next column
  if (col == colmax) col = 0;   // wrap back to the first column when we get to the end

  if (frameCount % AdjustBlurSpectrum == 0) filter(BLUR, 0.572);  // > 0.575

  // Temps
  if ((! Pause) && (! Fin)) AfficheTemps(temps);
  temps = temps / 1000;
}

float YPitch(float w) {
  return ((500 - w) / 2) + 100;
}

float YIntensity(float w) {
  if (w < 40) w= 40;
  return ((100 - w) * 3) + 312;
}

void AfficheTemps(float T) {
  T = T / 1000;
  x = 728;
  fill(0);
  rect(x - 3, 587, 100, 15);
  fill(255);
  textFont(maFonte, 12);
  text(T + " sec", x, 590);
}

void EffaceEcran() {
  // background(255); // Fond blanc
  // noStroke(); // pas de contour
  xAvantPitch = 0;
  yAvantPitch = YPitch(75) ;
  xAvantIntensity = 0;
  yAvantIntensity = YIntensity(40) ;
}


void Debut() {
  TempsPause = millis();
  IndexPitch = 0;
  IndexIntensity = 0;
  IndexXMLSpectre = 0;
  IndexXMLCouche4 = 0;
  EffaceEcran();
  PlayerAudioDebut();
}


void PlayerAudioDebut() {
  MonPlayer.close();
  MonPlayer = minim.loadFile(NomFichierAudio, 2048);
  MonPlayer.play();
}


void keyPressed() {
  // println("key = " + key);
  if (key == ' ') {         // barre d'espace
    ToucheEspace = ! ToucheEspace;
    Pause = ToucheEspace;
    if (Pause) {
      MonPlayer.pause();
      TempsDebutPause = millis();
    }
    else {
      MonPlayer.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else  if ( key == 'p' || key == 'P' )
  {
    CoucheSpectre = 0; // P Phonème
    Debut();
  }
  else if (key == 'y' || key == 'Y')
  {
    CoucheSpectre = 1; // Y Syllabe
    Debut();
  }
  else if (key == 'm' || key == 'M')
  {
    CoucheSpectre = 2; // M Mot
    Debut();
  }
  else if (key == 'h' || key == 'H')
  {
    CoucheSpectre = 3; // H Phonétique
    Debut();
  }
  else if (key == 'o' || key == 'O')
  {
    CoucheSpectre = 4; // O Orthographique
    Debut();
  }
  else if (key == 's' || key == 'S') saveFrame(timestamp()+"_##.png");
  else if (keyPressed && (key == CODED)) { // If it's a coded key
    if (keyCode == LEFT) {            // Left arrow
      FacteurX = FacteurX / 2;
      Debut();
    } 
    else if (keyCode == RIGHT) {      // Right arrow
      FacteurX = FacteurX * 2;
      Debut();
    }
  }

  {
    // println("key = " + key  + "  Erreur taper Espace");
  }
}


String timestamp() {
  Calendar now = Calendar.getInstance();
  println("Frame saved");
  //  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}


void stop() {
  // always close Minim audio classes when you are done with them
  MonPlayer.close();
  minim.stop();
  super.stop();
}

